/*
 * XLife Copyright 1989 Jon Bennett jb7m+@andrew.cmu.edu, jcrb@cs.cmu.edu
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include "defs.h"

static char *strs[] = { 
#include "help.h"
0
};

void redraw_help(void) {
    int i;

    XClearWindow(disp, helpw);
    for (i = 0; strs[i]; i++)
	XDrawString(disp, helpw, ntextgc, 10, i*12 + 25, strs[i], strlen(strs[i]));
}

void help(void) {
    helpw_mode = -1;
    XRaiseWindow(disp, helpw);
    redraw_help();
    getxstring();
    XLowerWindow(disp, helpw);
    helpw_mode = 0;
}

void redraw_viewvars(void) {
    int k = 0, i;

    XClearWindow(disp, helpw);
    if (stashed[0]) {
          sprintf(inpbuf, "Last loaded file name: %s", stashed);
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
          sprintf(inpbuf, "Quantity of scripts to save: %d", i = loadscriptstat());
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
          if (i--) {
             sprintf(inpbuf, "%s", loadscriptfn(1));
             while (i--)
               sprintf(inpbuf + strlen(inpbuf), " %s", loadscriptfn(0));
             XDrawString(disp, helpw, ntextgc, 25, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
          }
          sprintf(inpbuf, "Number of comment lines: %d", numcomments);
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
          if (outcome[0]) {
            sprintf(inpbuf, "#K line: %s", outcome);
            XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
          }
    }
    sprintf(inpbuf, "Save file format: %c", saveformat);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    sprintf(inpbuf, "Density for the random filled area: %.2f%%", rnd_density*100);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    if (randomseed) {
          sprintf(inpbuf, "Random generator seed: %d", randomseed);
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    }
    sprintf(inpbuf, "Delay for the evolution (msec): %u", delay);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    sprintf(inpbuf, "Jump length for `go' command: %d", hideperiod);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    if (fname[0]) {
          sprintf(inpbuf, "Internal file name: %s", fname);
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    }
    sprintf(inpbuf, "Topology: %c ", topology);
    if (limits) {
          if (limits&1)
            sprintf(inpbuf + strlen(inpbuf), "%lux", x_max_limit - x_min_limit);
          else
            sprintf(inpbuf + strlen(inpbuf), "%lux", 1LU << 32);
          if (limits&2)
            sprintf(inpbuf + strlen(inpbuf), "%lu", y_max_limit - y_min_limit);
          else
            sprintf(inpbuf + strlen(inpbuf), "%lu", 1LU << 32);
    }
    else
          sprintf(inpbuf + 12, "%lux%lu", 1LU << 32, 1UL << 32);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    if (*pathtorules) {
          sprintf(inpbuf, "Path to the file with rules: %s", pathtorules);
          XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    }
    hashstat();
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    sprintf(inpbuf, "Multicolor mode: %d", multicolor);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    sprintf(inpbuf, "Show changes only mode: %d", changesonly);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    sprintf(inpbuf, "Pseudocolor mode: %d", pseudocolor);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    bounding_box(&active);
    sprintf(inpbuf, "Active pattern size: %dx%d", active.xmax - active.xmin,
                    active.ymax - active.ymin);
    XDrawString(disp, helpw, ntextgc, 10, ++k*FONTHEIGHT, inpbuf, strlen(inpbuf));
    XDrawString(disp, helpw, ntextgc, 5, (k + 2)*FONTHEIGHT, "Press Enter to continue", 23);
}

void viewvars(void) {
    helpw_mode = -2;
    XRaiseWindow(disp, helpw);
    redraw_viewvars();
    getxstring();
    XLowerWindow(disp, helpw);
    helpw_mode = 0;
}

int redraw_comments(void) {
   int i = 0;

   XClearWindow(disp, helpw);
   while (height > (i + 3)*FONTHEIGHT && helpw_mode + i < numcomments) {
      XDrawString(disp, helpw, ntextgc, 10, (i + 1)*FONTHEIGHT,
                comments[helpw_mode + i], strlen(comments[helpw_mode + i]));
      i++;
   }
   XDrawString(disp, helpw, ntextgc, 5, (i + 2)*FONTHEIGHT, "Press Enter to continue", 23);
   return i;
}

void view_comments(void) {
   if (numcomments) {
      XRaiseWindow(disp, helpw);
      do {
          eo_comments = redraw_comments();
          getxstring();
          helpw_mode += eo_comments;
      } while (helpw_mode < numcomments);
      XLowerWindow(disp, helpw);
   }
   eo_comments = helpw_mode = 0;
}
